lib

# Class: AttributeType

Source Location: /lib/schema.inc

### Class Overview

    SchemaItem
       |
       --AttributeType

Represents an LDAP AttributeType

### Variables

- $aliases
- $equality
- $is_collective
- $is_no_user_modification
- $is_obsolete
- $is_single_value
- $max_length
- $name
- $ordering
- $required_by_object_classes
- $sub_str
- $sup_attribute
- $syntax
- $type
- $usage
- $used_in_object_classes

### Methods

- AttributeType
- addAlias
- addRequiredByObjectClass
- addUsedInObjectClass
- getAliases
- getEquality
- getIsCollective
- getIsNoUserModification
- getIsObsolete
- getIsSingleValue
- getMaxLength
- getName
- getOrdering
- getRequiredByObjectClasses
- getSubstr
- getSupAttribute
- getSyntaxOID
- getSyntaxString
- getType
- getUsage
- getUsedInObjectClasses
- initVars
- isAliasFor
- removeAlias
- setAliases
- setIsSingleValue
- setName
- setSupAttribute
- setType

### Inherited Variables

#### Class: SchemaItem

SchemaItem::$description
SchemaItem::$oid

### Inherited Methods

#### Class: SchemaItem

SchemaItem::SchemaItem()
  Default constructor.
SchemaItem::getDescription()
SchemaItem::getOID()
SchemaItem::initVars()
  Initialize class members to default values.
SchemaItem::setDescription()
SchemaItem::setOID()

### Class Details

[line 514]
Represents an LDAP AttributeType
[ Top ]

### Class Variables

#### $aliases =

[line 539]

An array of alias attribute names, strings

Type: | mixed

[ Top ]

#### $equality =

[line 523]

The equality rule used

Type: | mixed

[ Top ]

#### $is_collective =

[line 533]

boolean: is collective?

Type: | mixed

[ Top ]

#### $is_no_user_modification =

[line 535]

boolean: can use modify?

Type: | mixed

[ Top ]

#### $is_obsolete =

[line 519]

string: the description

Type: | mixed

[ Top ]

#### $is_single_value =

[line 531]

boolean: is single valued only?

Type: | mixed

[ Top ]

#### $max_length =

[line 541]

The max number of characters this attribute can be

Type: | mixed

[ Top ]

#### $name =

[line 517]

The name of this attributeType

Type: | mixed

[ Top ]

#### $ordering =

[line 525]

The ordering of the attributeType

Type: | mixed

[ Top ]

#### $required_by_object_classes = array()

[line 547]

A list of object class names that require this attribute type.

Type: | mixed

[ Top ]

#### $sub_str =

[line 527]

Boolean: supports substring matching?

Type: | mixed

[ Top ]

#### $sup_attribute =

[line 521]

The attribute from which this attribute inherits (if any)

Type: | mixed

[ Top ]

#### $syntax =

[line 529]

The full syntax string, ie 1.2.3.4{16}

Type: | mixed

[ Top ]

#### $type =

[line 543]

A string description of the syntax type (taken from the LDAPSyntaxes)

Type: | mixed

[ Top ]

#### $usage =

[line 537]

The usage string set by the LDAP schema

Type: | mixed

[ Top ]

#### $used_in_object_classes =

[line 545]

An array of objectClasses which use this attributeType (must be set by caller)

Type: | mixed

[ Top ]

### Class Methods

### constructor AttributeType [line 579]

`AttributeType AttributeType( $raw_ldap_attr_string)`

Creates a new AttributeType objcet from a raw LDAP AttributeType string.

#### Parameters:

| $raw_ldap_attr_string |

[ Top ]

### method addAlias [line 878]

`void addAlias( string $new_alias_name)`

Adds an attribute name to the alias array.

#### Parameters:

string | $new_alias_name | The name of a new attribute to add to this attribute's list of aliases.

[ Top ]

### method addRequiredByObjectClass [line 948]

`void addRequiredByObjectClass( string $object_class_name)`

Adds an objectClass name to this attribute's list of "required by" objectClasses, that is the list of objectClasses which must have this attribute.

#### Parameters:

string | $object_class_name | The name of the objectClass to add.

[ Top ]

### method addUsedInObjectClass [line 924]

`void addUsedInObjectClass( string $object_class_name)`

Adds an objectClass name to this attribute's list of "used in" objectClasses, that is the list of objectClasses which provide this attribute.

#### Parameters:

string | $object_class_name | The name of the objectClass to add.

[ Top ]

### method getAliases [line 761]

`array getAliases( )`

Gets the names of attributes that are an alias for this attribute (if any).

#### Tags:

return: | An array of names of attributes which alias this attribute or an empty array if no attribute aliases this object.

[ Top ]

### method getEquality [line 733]

`string getEquality( )`

Gets this attribute's equality string
[ Top ]

### method getIsCollective [line 833]

`bool getIsCollective( )`

Gets whether this attribute is collective.

#### Tags:

return: | Returns true if this attribute is collective and false otherwise.

[ Top ]

### method getIsNoUserModification [line 842]

`bool getIsNoUserModification( )`

Gets whether this attribute is not modifiable by users.

#### Tags:

return: | Returns true if this attribute is not modifiable by users.

[ Top ]

### method getIsObsolete [line 705]

`bool getIsObsolete( )`

Gets whether this attribute has been flagged as obsolete by the LDAP server
[ Top ]

### method getIsSingleValue [line 815]

`bool getIsSingleValue( )`

Gets whether this attribute is single-valued. If this attribute only supports single values, true is returned. If this attribute supports multiple values, false is returned.

#### Tags:

return: | Returns true if this attribute is single-valued or false otherwise.

[ Top ]

### method getMaxLength [line 805]

`int getMaxLength( )`

Gets this attribute's the maximum length. If no maximum is defined by the LDAP server, null is returned.

#### Tags:

return: | The maximum length (in characters) of this attribute or null if no maximum is specified.

[ Top ]

### method getName [line 696]

`string getName( )`

Gets this attribute's name
[ Top ]

### method getOrdering [line 742]

`string getOrdering( )`

Gets this attribute's ordering specification.
[ Top ]

### method getRequiredByObjectClasses [line 962]

`array getRequiredByObjectClasses( )`

Gets the list of "required by" objectClasses, that is the list of objectClasses which provide must have attribute.

#### Tags:

return: | An array of names of objectclasses (strings) which provide this attribute

[ Top ]

### method getSubstr [line 751]

`string getSubstr( )`

Gets this attribute's substring matching specification
[ Top ]

### method getSupAttribute [line 724]

`string getSupAttribute( )`

Gets this attribute's parent attribute (if any). If this attribute does not inherit from another attribute, null is returned.
[ Top ]

### method getSyntaxOID [line 796]

`string getSyntaxOID( )`

Gets this attribute's syntax OID. Differs from getSyntaxString() in that this function only returns the actual OID with any length specification removed.

Ie, if the syntax string is "1.2.3.4{16}", this function only retruns "1.2.3.4".

#### Tags:

return: | The syntax OID string.

[ Top ]

### method getSyntaxString [line 784]

`string getSyntaxString( )`

Gets this attribute's raw syntax string (ie: "1.2.3.4{16}").

#### Tags:

return: | The raw syntax string

[ Top ]

### method getType [line 851]

`string getType( )`

Gets this attribute's type

#### Tags:

return: | The attribute's type.

[ Top ]

### method getUsage [line 714]

`string getUsage( )`

Gets this attribute's usage string as defined by the LDAP server
[ Top ]

### method getUsedInObjectClasses [line 938]

`array getUsedInObjectClasses( )`

Gets the list of "used in" objectClasses, that is the list of objectClasses which provide this attribute.

#### Tags:

return: | An array of names of objectclasses (strings) which provide this attribute

[ Top ]

### method initVars [line 552]

`void initVars( )`

Initialize the class' member variables
Overrides SchemaItem::initVars() (Initialize class members to default values.)
[ Top ]

### method isAliasFor [line 771]

`bool isAliasFor( string $attr_name)`

Returns whether the specified attribute is an alias for this one (based on this attribute's alias list).

#### Tags:

return: | True if the specified attribute is an alias for this one, or false otherwise.

#### Parameters:

string | $attr_name | The name of the attribute to check.

[ Top ]

### method removeAlias [line 862]

`bool removeAlias( string $remove_alias_name)`

Removes an attribute name from this attribute's alias array.

#### Tags:

return: | true on success or false on failure (ie, if the specified attribute name is not found in this attribute's list of aliases)

#### Parameters:

string | $remove_alias_name | The name of the attribute to remove.

[ Top ]

### method setAliases [line 905]

`void setAliases( array $new_aliases)`

Sets this attribute's list of aliases.

#### Parameters:

array | $new_aliases | The array of alias names (strings)

[ Top ]

### method setIsSingleValue [line 824]

`void setIsSingleValue( bool $is_single_value)`

Sets whether this attribute is single-valued.

#### Parameters:

bool | $is_single_value |

[ Top ]

### method setName [line 887]

`void setName( string $new_name)`

Sets this attriute's name.

#### Parameters:

string | $new_name | The new name to give this attribute.

[ Top ]

### method setSupAttribute [line 896]

`void setSupAttribute( string $new_sup_attr)`

Sets this attriute's SUP attribute (ie, the attribute from which this attribute inherits).

#### Parameters:

string | $new_sup_attr | The name of the new parent (SUP) attribute

[ Top ]

### method setType [line 914]

`void setType( string $new_type)`

Sets this attribute's type.

#### Parameters:

string | $new_type | The new type.

[ Top ]

Documentation generated on Tue, 22 Nov 2011 16:30:07 +0100 by phpDocumentor 1.4.1